import { ChangeSet, StateEffect, Extension, EditorState, Transaction } from '@codemirror/state';

interface Update {
    changes: ChangeSet;
    effects?: readonly StateEffect<any>[];
}
declare type CollabConfig = {
    startVersion?: number;
    clientID?: string;
    sharedEffects?: (tr: Transaction) => readonly StateEffect<any>[];
};
declare function collab(config?: CollabConfig): Extension;
declare function receiveUpdates(state: EditorState, updates: readonly Update[], ownUpdateCount: number): Transaction;
declare function sendableUpdates(state: EditorState): readonly (Update & {
    origin: Transaction;
})[];
declare function getSyncedVersion(state: EditorState): number;
declare function getClientID(state: EditorState): string;

export { Update, collab, getClientID, getSyncedVersion, receiveUpdates, sendableUpdates };
